<?xml version="1.0" encoding="utf-8" ?>
<xml>
<?php
function CastToXBytes($size)
{
	if ( $size < 1024 ) {
		$result = $size . " bytes";
	} elseif ( $size < 1048576 ) {
		$result = ($size / 1024.0) . "KB";
	} elseif ( $size < 1073741824 ) {
		$result = ($size / 1048576.0) . "MB";
	} else {
		$result = ($size / 1073741824.0) . "GB";
	}
	return $result;
}

function StatusString($file)
{
	if ( $file->status == 7 ) {
		return "Paused";
	} elseif ( $file->src_count_xfer > 0 ) {
		return "Downloading";
	} else {
		return "Waiting";
	}
}

function PrioString($file)
{
	$prionames = array(0 => "Low", 1 => "Normal", 2 => "High",
		3 => "Very high", 4 => "Very low", 5=> "Auto", 6 => "Powershare");
	$result = $prionames[$file->prio];
	if ( $file->prio_auto == 1) {
		$result = $result . "(auto)";
	}
	return $result;
}

//
// declare it here, before any function reffered it in "global"
//
$sort_order;$sort_reverse;

function my_cmp($a, $b)
{
	global $sort_order, $sort_reverse;
	
	switch ( $sort_order) {
		case "size": $result = $a->size > $b->size; break;
		case "name": $result = $a->name > $b->name; break;
		case "xfer": $result = $a->xfer > $b->xfer; break;
		case "accept": $result = $a->accept > $b->accept; break;
		case "req": $result = $a->req > $b->req; break;
		case "prio": $result = PrioString($a) > PrioString($b); break;
	}

	if ( $sort_reverse ) {
		$result = !$result;
	}
	//var_dump($sort_reverse);
	return $result;
}

//
// perform command before processing content
//
//var_dump($HTTP_GET_VARS);
if (($HTTP_GET_VARS["command"] != "") && ($_SESSION["guest_login"] == 0)) {
	//amule_do_download_cmd($HTTP_GET_VARS["command"]);
	foreach ( $HTTP_GET_VARS as $name => $val) {
		// this is file checkboxes
		if ( (strlen($name) == 32) and ($val == "on") ) {
			//var_dump($name);var_dump($val);
			amule_do_shared_cmd($name, $HTTP_GET_VARS["command"]);
		}
	}
	if ($HTTP_GET_VARS["command"] == "reload") {
		amule_do_reload_shared_cmd();
	}
}
$shared = amule_load_vars("shared");

$sort_order = $HTTP_GET_VARS["sort"];

if ( $sort_order == "" ) {
	$sort_order = $_SESSION["shared_sort"];
} else {
	if ( $_SESSION["sort_reverse"] == "" ) {
		$_SESSION["sort_reverse"] = 0;
	} else {
		$_SESSION["sort_reverse"] = !$_SESSION["sort_reverse"];
	}
}
//var_dump($_SESSION);
$sort_reverse = $_SESSION["sort_reverse"];
if ( $sort_order != "" ) {
	$_SESSION["shared_sort"] = $sort_order;
	usort(&$shared, "my_cmp");
}

foreach ($shared as $file) {
	
	echo "<shared_file>\n";
	echo "\t<hash><![CDATA[", $file->hash, "]]></hash>\n";
	echo "\t<short_name><![CDATA[", $file->short_name, " ]]></short_name>\n";
	echo "\t<xfer><![CDATA[", CastToXBytes($file->xfer), "]]></xfer>\n";
	echo "\t<req><![CDATA[", $file->req, "]]></req>\n";
	echo "\t<accept><![CDATA[", $file->accept, "]]></accept>\n";
	echo "\t<size><![CDATA[", CastToXBytes($file->size), "]]></size>\n";
	echo "\t<prio><![CDATA[", PrioString($file), "]]></prio>\n";
	echo "</shared_file>\n";
}
?>
<?php
	$stats = amule_get_stats();
	echo "<status>\n";
	echo "\t<id><![CDATA[", $stats["id"], "]]></id>\n";
	echo "\t<serv_name><![CDATA[", $stats["serv_name"], "]]></serv_name>\n";
	echo "\t<serv_addr><![CDATA[", $stats["serv_addr"], " ]]></serv_addr>\n";
	echo "\t<string><![CDATA[";
		if ( $stats["id"] == 0 ) {
			echo "Not connected";
		} elseif ( $stats["id"] == 0xffffffff ) {
			echo "Connecting ...";
		} else {
			echo "Connected with ", (($stats["id"] < 16777216) ? "low" : "high"), " ID to ",
				$stats["serv_name"], "  ", $stats["serv_addr"];
		}
	echo " ]]></string>\n";
	echo "</status>\n";
?>
</xml>