function PrefsSection() {
	timer.set_delay(60);
	this.set_section();
	this.refresh_address = "ajax-prefs.php";
	this.initialised = 0;
	this.draw_table();
	this.init_size();
	
	this.str_param_names = new Array(
		"max_line_down_cap", "max_line_up_cap",
		"max_up_limit", "max_down_limit", "max_file_src",
		"slot_alloc", "max_conn_total",
		"tcp_port", "udp_port",
		"min_free_space" /*, "autorefresh_time"*/
		)
	
	this.check_param_names = new Array(
		"autoconn_en", "reconn_en", "udp_dis", "new_files_paused",
		"aich_trust", "alloc_full", "alloc_full_chunks",
		"check_free_space", "extract_metadata", "ich_en",
		"new_files_auto_dl_prio", "new_files_auto_ul_prio",
		"use_gzip"
		)
		
	reload();
}

PrefsSection.prototype.set_section = function() {
	document.getElementById("section").innerHTML = '<div id="prefs"></div>';
}

// initialise div sizes (transfert_dl div)
PrefsSection.prototype.init_size = function() {
	var used_height = 0;

	var resized_div = document.getElementById("prefs");
	resized_div.style.height = document.getElementById("section").offsetHeight - used_height;
}

// On refresh action
PrefsSection.prototype.refresh = function(responseXML) {
	if(this.initialised != 1) {
		this.initialised != 1
		
		this.init_data(responseXML);
	}
}


PrefsSection.prototype.init_data = function (responseXML)
{
	var i;
	var prefsForm = document.forms.prefsForm


	for(i = 0; i < this.str_param_names.length; i++) {
		var form_item = prefsForm[this.str_param_names[i]];
		if(!form_item) alert(this.str_param_names[i] +": Not in form");
		if(form_item)
			form_item.value = responseXML.getElementsByTagName(this.str_param_names[i]).item(0).firstChild.data;
	}

	for(i = 0; i < this.check_param_names.length; i++) {
		var form_item = prefsForm[this.check_param_names[i]];
		if(!form_item) alert(this.check_param_names[i] +": Not in form");
		if(form_item)
			form_item.checked = responseXML.getElementsByTagName(this.check_param_names[i]).item(0).firstChild.data == "1" ? true : false;
	}
}

PrefsSection.prototype.submit = function () {
	var address = this.refresh_address +"?command=prefs";
	var i;
	var prefsForm = document.forms.prefsForm
	
	for(i = 0; i < this.str_param_names.length; i++) {
		var form_item = prefsForm[this.str_param_names[i]];
		if(form_item)
			address += "&"+this.str_param_names[i]+"="+form_item.value;
	}
	
	for(i = 0; i < this.check_param_names.length; i++) {
		var form_item = prefsForm[this.check_param_names[i]];
		if(form_item)
			address += "&"+this.check_param_names[i]+"="+(form_item.checked?1:0);
	}
	alert(address);
	reload(address);
}

PrefsSection.prototype.draw_table = function (){
	var output = "";
	output += '<form name="prefsForm" action="#" onsubmit="javascript:Section.submit(); return false;">';
	output += '    <table class="prefs">';
	output += '        <tr>';
	output += '          <td colspan="4"><strong>Webserver</strong></td>';
	output += '        </tr>';
	output += '        <!--';
	output += '        <tr>';
	output += '          <td>Page refresh interval </td>';
	output += '          <td><input name="autorefresh_time" type="text" id="autorefresh_time" size="4"></td>';
	output += '          <td width="28%">&nbsp;</td>';
	output += '          <td>&nbsp;</td>';
	output += '        </tr>';
	output += '        -->';
	output += '        <tr>';
	output += '          <td width="25%"><input name="use_gzip" type="checkbox" id="use_gzip">';
	output += '            Use gzip compression </td>';
	output += '          <td width="11%">&nbsp;</td>';
	output += '          <td>&nbsp;</td>';
	output += '          <td width="36%">&nbsp;</td>';
	output += '        </tr>';
	output += '    </table>';
	output += '    <table class="prefs">';
	output += '        <tr>';
	output += '          <td colspan="5"><strong>Line capacity (for statistics only) </strong></td>';
	output += '        </tr>';
	output += '        <tr>';
	output += '          <td width="18%">Max download rate </td>';
	output += '          <td width="11%"><input name="max_line_down_cap" type="text" id="max_line_down_cap" size="4"></td>';
	output += '          <td width="16%">Max upload rate </td>';
	output += '          <td width="19%"><input name="max_line_up_cap" type="text" id="max_line_up_cap" size="4"></td>';
	output += '          <td width="36%">&nbsp;</td>';
	output += '        </tr>';
	output += '    </table>';
	output += '    <table class="prefs">';
	output += '            <tr>';
	output += '              <td colspan="5"><strong>Bandwidth limits</strong></td>';
	output += '            </tr>';
	output += '            <tr>';
	output += '              <td width="18%">Max download rate';
	output += '              </td>';
	output += '              <td width="11%"><input name="max_down_limit" type="text" id="max_down_limit" size="4"></td>';
	output += '              <td width="16%">Max upload rate                  </td>';
	output += '              <td width="19%"><input name="max_up_limit" type="text" id="max_up_limit" size="4"></td>';
	output += '              <td width="36%">Slot allocation';
	output += '                <input name="slot_alloc" type="text" id="slot_alloc" size="4"></td>';
	output += '      </tr>';
	output += '    </table>';
	output += '    <table class="prefs">';
	output += '        <tr>';
	output += '          <td colspan="5"><strong>Connection settings </strong></td>';
	output += '        </tr>';
	output += '        <tr>';
	output += '          <td width="30%">Max total connections (total) </td>';
	output += '          <td width="11%"><input name="max_conn_total" type="text" id="max_conn_total" size="4"></td>';
	output += '          <td width="20%">Max sources per file </td>';
	output += '          <td width="18%"><input name="max_file_src" type="text" id="max_file_src" size="4"></td>';
	output += '          <td width="21%">&nbsp;</td>';
	output += '        </tr>';
	output += '        <tr>';
	output += '          <td colspan="2"><input name="autoconn_en" type="checkbox" id="autoconn_en">';
	output += '            Autoconnect at startup </td>';
	output += '          <td>&nbsp;</td>';
	output += '          <td>&nbsp;</td>';
	output += '          <td>&nbsp;</td>';
	output += '        </tr>';
	output += '        <tr>';
	output += '          <td colspan="2"><input name="reconn_en" type="checkbox" id="reconn_en">';
	output += '            Reconnect when connection lost            </td>';
	output += '          <td>&nbsp;</td>';
	output += '          <td>&nbsp;</td>';
	output += '          <td>&nbsp;</td>';
	output += '        </tr>';
	output += '    </table>';
	output += '    <table class="prefs">';
	output += '      <tr>';
	output += '        <td colspan="5"><strong>Network settings </strong></td>';
	output += '      </tr>';
	output += '      <tr>';
	output += '        <td width="13%">TCP port </td>';
	output += '        <td width="23%"><input name="tcp_port" type="text" id="tcp_port" size="4"></td>';
	output += '        <td width="12%">UDP port </td>';
	output += '        <td width="17%"><input name="udp_port" type="text" id="udp_port" size="4"></td>';
	output += '        <td width="35%"><input name="udp_dis" type="checkbox" id="udp_dis">';
	output += '          Disable UDP connections          </td>';
	output += '      </tr>';
	output += '    </table>';
	output += '    <table class="prefs">';
	output += '      <tr>';
	output += '        <td colspan="4"><strong>File settings </strong></td>';
	output += '      </tr>';
	output += '      <tr>';
	output += '        <td width="27%">Minimum free space (Mb)</td>';
	output += '        <td width="15%"><input name="min_free_space" type="text" id="min_free_space" size="4"></td>';
	output += '        <td width="3%">&nbsp;</td>';
	output += '        <td width="51%"><input name="check_free_space" type="checkbox" id="check_free_space">';
	output += '          Check free space          </td>';
	output += '      </tr>';
	output += '      <tr>';
	output += '        <td colspan="2"><input name="new_files_auto_dl_prio" type="checkbox" id="new_files_auto_dl_prio">';
	output += '    Added download files have auto priority</td>';
	output += '        <td>&nbsp;</td>';
	output += '        <td>&nbsp;</td>';
	output += '      </tr>';
	output += '      <tr>';
	output += '        <td colspan="2"><input name="new_files_auto_ul_prio" type="checkbox" id="new_files_auto_ul_prio">';
	output += '          New shared files have auto priority</td>';
	output += '        <td>&nbsp;</td>';
	output += '        <td>&nbsp;</td>';
	output += '      </tr>';
	output += '      <tr>';
	output += '        <td colspan="2"><input name="ich_en" type="checkbox" id="ich_en">';
	output += '          I.C.H. active</td>';
	output += '        <td>&nbsp;</td>';
	output += '        <td>&nbsp;</td>';
	output += '      </tr>';
	output += '      <tr>';
	output += '        <td colspan="2"><input name="aich_trust" type="checkbox" id="aich_trust">';
	output += '          AICH trusts every hash (not recommended)</td>';
	output += '        <td>&nbsp;</td>';
	output += '        <td>&nbsp;</td>';
	output += '      </tr>';
	output += '      <tr>';
	output += '        <td colspan="2"><input name="alloc_full_chunks" type="checkbox" id="alloc_full_chunks">';
	output += '          Alloc full chunks of .part files</td>';
	output += '        <td>&nbsp;</td>';
	output += '        <td>&nbsp;</td>';
	output += '      </tr>';
	output += '      <tr>';
	output += '        <td colspan="2"><input name="alloc_full" type="checkbox" id="alloc_full">';
	output += '          Alloc full disk space for .part files</td>';
	output += '        <td>&nbsp;</td>';
	output += '        <td>&nbsp;</td>';
	output += '      </tr>';
	output += '      <tr>';
	output += '        <td colspan="2"><input name="new_files_paused" type="checkbox" id="new_files_paused">';
	output += '          Add files to download queue in pause mode</td>';
	output += '        <td>&nbsp;</td>';
	output += '        <td>&nbsp;</td>';
	output += '      </tr>';
	output += '      <tr>';
	output += '        <td colspan="2"><input name="extract_metadata" type="checkbox" id="extract_metadata">';
	output += '          Extract metadata tags</td>';
	output += '        <td>&nbsp;</td>';
	output += '        <td align="right">';
	output += '			     <input type="submit" name="Submit" value="Apply">';
	output += '        </td>';
	output += '      </tr>';
	output += '    </table>';
	output += '</form>';
	document.getElementById("prefs").innerHTML = output;
}
