function StatsSection() {
	timer.set_delay(20);
	this.set_section();
	this.init_size();
	this.refresh_address = "ajax-stats_tree.php";
	this.stat_tree_max_width  = 700;
	this.branch_status = new Array();
	
	this.openImg = new Image();
	this.closedImg = new Image();
	this.openImg.src = "tree-open.gif";
	this.closedImg.src = "tree-closed.gif";
}

StatsSection.prototype.set_section = function() {
	document.getElementById("section").innerHTML = '<div id="stat_table">Waiting for server reply</div><div id="stat_images"></div>';
}

// initialise div sizes (search_table div)
StatsSection.prototype.init_size = function() {
	var used_height = 0;
	var used_width  = 500; //document.getElementById("stat_images").offsetWidth;
  var free_width  = 0;
  var resized_div = document.getElementById("stat_table");
	
	resized_div.style.height = document.getElementById("section").offsetHeight - used_height;
	
	free_width = document.getElementById("section").offsetWidth - used_width
	resized_div.style.width = (free_width > 700)? 700:free_width ;
	
}

// On refresh action
StatsSection.prototype.refresh = function(responseXML) {
	document.getElementById("stat_table").innerHTML = this.draw_stat_tree(responseXML.documentElement.getElementsByTagName("stats_tree").item(0), 0);
	
	var currentDate = new Date();
	var stamp = currentDate.getTime();
	var output = '<img src="amule_stats_download.png?'+stamp+'" width="500" height="200" border="0" alt="" title="" />';
	output += '<br>Download speed<br><br>';
	output += '<img src="amule_stats_upload.png?'+stamp+'" width="500" height="200" border="0" alt="" title="" />';
	output += '<br>Upload speed';
	document.getElementById("stat_images").innerHTML = output;
	
}


StatsSection.prototype.draw_stat_tree = function(docXML) {
	var output = "";
	var i;
	
	if(docXML.attributes.length > 0 ) {
		idx = docXML.attributes.getNamedItem("idx").value;
	}
	else {
		idx = 0;
	}
	for(i=0;i<docXML.childNodes.length; i++) {
		var imgSrc;
		if(this.branch_status[idx] == "closed" ) {
			imgSrc="tree-closed.gif";
			branchDisplay="none";
		}
		else {
			this.branch_status[idx] = "open";
			imgSrc="tree-open.gif";
			branchDisplay="block";			
		}
		if ( docXML.childNodes[i].nodeName == "category" ) {
			output += '<span class="trigger" onClick="Section.showBranch('+idx+')">\n';
			output += '<img src="'+imgSrc+'" border="0" id="fl_'+ idx +'">'+docXML.childNodes[i].attributes.getNamedItem("label").value+'<br>\n';
			output += '</span>\n';
			output += '<span class="branch" id="br_'+ idx +'" style="display: '+branchDisplay+'">\n';
			output += this.draw_stat_tree(docXML.childNodes[i]);
		}
		else if ( docXML.childNodes[i].nodeName == "item" ) {
			output += '<img src="tree-leaf.gif">'+docXML.childNodes[i].firstChild.data+'<br>\n';
		}
	}
	output += "</span>\n";
	
	return output;
}

StatsSection.prototype.showBranch = function(idx){
	var objBranch = document.getElementById("br_"+idx).style;
	var objImg = document.getElementById("fl_"+idx);
	
	if(this.branch_status[idx] == "closed" ) {
		objImg.src = this.openImg.src;
		objBranch.display="block";
		this.branch_status[idx] = "open";
	}
	else {
		objImg.src = this.closedImg.src;
		objBranch.display="none";
		this.branch_status[idx] = "closed";
	}
}
